<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2012 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: class.ForumSubCats.php
| Version: 0.2.1
| Author: Yodix (www.on-deck.eu)
| Release Date: 25/02/2012
| Last Update Date: 14/03/2012
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

class ForumSubCats {
	public $_subCatsEnabled = 0;
	
	public function subForumsList($forum_id) {
		global $locale;
		
		$subList = "";
		if ($this->_subCatsEnabled == "1") {
			$i = 1;
			
			$subResult = dbquery("SELECT forum_id, forum_name FROM ".DB_FORUMS." WHERE forum_main='".$forum_id."'");
			$subCheck = dbrows($subResult);
			if ($subCheck != "0") {
				$subList .= "<span class='small'>";
				$subList .= "<strong>".$locale['fsc_000'].":</strong>&nbsp;";
				while ($subData = dbarray($subResult)) {
					$subList .= "<a href='viewforum.php?forum_id=".$subData['forum_id']."'>".$subData['forum_name']."</a>";
					if ($i != $subCheck) {
						$subList .= ",&nbsp;";
					}
					$i++;
				}
				$subList .= "</span>";
			}
		}
		
		return $subList;
	}
	
	public function showSubForums($forum_id) {
		global $locale, $lastvisited, $userdata;
		
		if ($this->_subCatsEnabled == "1") {
			echo "<table cellpadding='0' cellspacing='1' width='100%' class='tbl-border forum_idx_table'>\n";

			$forum_list = ""; $current_cat = "";
			$result = dbquery(
				"SELECT f.*, f2.forum_name AS forum_cat_name, u.user_id, u.user_name, u.user_status
				FROM ".DB_FORUMS." f
				LEFT JOIN ".DB_FORUMS." f2 ON f.forum_cat = f2.forum_id
				LEFT JOIN ".DB_USERS." u ON f.forum_lastuser = u.user_id
				WHERE ".groupaccess('f.forum_access')." AND f.forum_cat!='0' AND f.forum_main='".$forum_id."'
				GROUP BY forum_id ORDER BY f2.forum_order ASC, f.forum_order ASC"
			);
			if (dbrows($result) != 0) {
				echo "<tr>\n<td colspan='2' class='forum-caption forum_cat_name'><!--forum_cat_name-->".$locale['fsc_000']."</td>\n";
				echo "<td align='center' width='1%' class='forum-caption' style='white-space:nowrap'>".$locale['402']."</td>\n";
				echo "<td align='center' width='1%' class='forum-caption' style='white-space:nowrap'>".$locale['403']."</td>\n";
				echo "<td width='1%' class='forum-caption' style='white-space:nowrap'>".$locale['404']."</td>\n";
				echo "</tr>\n";
				while ($data = dbarray($result)) {
					$moderators = "";
					if ($data['forum_moderators']) {
						$mod_groups = explode(".", $data['forum_moderators']);
						foreach ($mod_groups as $mod_group) {
							if ($moderators) $moderators .= ", ";
							$moderators .= $mod_group<101 ? "<a href='".BASEDIR."profile.php?group_id=".$mod_group."'>".getgroupname($mod_group)."</a>" : getgroupname($mod_group);
						}
					}
					$forum_match = "\|".$data['forum_lastpost']."\|".$data['forum_id'];
					if ($data['forum_lastpost'] > $lastvisited) {
						if (iMEMBER && ($data['forum_lastuser'] == $userdata['user_id'] || preg_match("({$forum_match}\.|{$forum_match}$)", $userdata['user_threads']))) {
							$fim = "<img src='".get_image("folder")."' alt='".$locale['561']."' />";
						} else {
							$fim = "<img src='".get_image("foldernew")."' alt='".$locale['560']."' />";
						}
					} else {
						$fim = "<img src='".get_image("folder")."' alt='".$locale['561']."' />";
					}
					echo "<tr>\n";
					echo "<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>$fim</td>\n";
					echo "<td class='tbl1 forum_name'><!--forum_name--><a href='viewforum.php?forum_id=".$data['forum_id']."'>".$data['forum_name']."</a><br />\n";
					if ($data['forum_description'] || $moderators) {
						echo "<span class='small'>".nl2br(parseubb($data['forum_description'])).($data['forum_description'] && $moderators ? "<br />\n" : "");
						echo ($moderators ? "<strong>".$locale['411']."</strong>".$moderators."</span>\n" : "</span>\n")."\n";
					}
					echo "</td>\n";
					echo "<td align='center' width='1%' class='tbl2' style='white-space:nowrap'>".$data['forum_threadcount']."</td>\n";
					echo "<td align='center' width='1%' class='tbl1' style='white-space:nowrap'>".$data['forum_postcount']."</td>\n";
					echo "<td width='1%' class='tbl2' style='white-space:nowrap'>";
					if ($data['forum_lastpost'] == 0) {
						echo $locale['405']."</td>\n</tr>\n";
					} else {
						echo showdate("forumdate", $data['forum_lastpost'])."<br />\n";
						echo "<span class='small'>".$locale['406'].profile_link($data['forum_lastuser'], $data['user_name'], $data['user_status'])."</span></td>\n";
						echo "</tr>\n";
					}
				}
			}
			echo "</table>\n";
		}
	}
	
	public function showForumsAdmin($forum_id) {
		global $locale, $aidlink;
		
		$subList = "";
		if (iADMIN && $this->_subCatsEnabled == "1") {
			$i = 1;
			
			$subResult = dbquery("SELECT forum_id, forum_name FROM ".DB_FORUMS." WHERE forum_main='".$forum_id."'");
			$subCheck = dbrows($subResult);
			if ($subCheck != "0") {
				$subList .= "<span class='small'>";
				$subList .= "<strong>".$locale['fsc_000'].":</strong>&nbsp;";
				while ($subData = dbarray($subResult)) {
					$subList .= $subData['forum_name']."&nbsp;";
					$subList .= "[<a href='".FUSION_SELF.$aidlink."&action=prune&forum_id=".$subData['forum_id']."&t=forum'>".$locale['fsc_013']."</a> -\n";
					$subList .= " <a href='".FUSION_SELF.$aidlink."&action=edit&forum_id=".$subData['forum_id']."&t=forum'>".$locale['fsc_011']."</a> :: ";
					$subList .= "<a href='".FUSION_SELF.$aidlink."&action=delete&forum_id=".$subData['forum_id']."&t=forum'>".$locale['fsc_012']."</a>]";
					if ($i != $subCheck) {
						$subList .= ",&nbsp;";
					}
					$i++;
				}
				$subList .= "</span>";
			}
		}
		
		return $subList;
	}
	
	public function showCaption($forum_id, $forum_cat_name, $forum_name) {
		$subResult = dbquery("SELECT forum_name, forum_main FROM ".DB_FORUMS." WHERE forum_id='".$forum_id."'");
		$subRows = dbrows($subResult);
		if ($subRows != "0") {
			$subData = dbarray($subResult);
			if ($subData['forum_main'] != "0") {
				$subMainData = dbarray(dbquery("SELECT forum_name, forum_main FROM ".DB_FORUMS." WHERE forum_id='".$subData['forum_main']."'"));
				if ($subMainData['forum_main'] == "0") {
					$subCaption = $forum_cat_name." &raquo; ".$subMainData['forum_name']." &raquo; ".$forum_name;
				} else {
					$subCaption = $forum_cat_name." &raquo; [...] &raquo;".$subMainData['forum_name']." &raquo; ".$forum_name;
				}
			} else {
				$subCaption = $forum_cat_name." &raquo; ".$forum_name;
			}
		}
		
		return $subCaption;
	}
	
	public function forumSubList($forum_id, $mainResult) {
		$forumList = ""; $currentCat = "";
		
		while ($mainData = dbarray($mainResult)) {
			if ($mainData['forum_cat_name'] != $currentCat) {
				if ($currentCat != "") { $forumList .= "</optgroup>\n"; }
				$currentCat = $mainData['forum_cat_name'];
				$forumList .= "<optgroup label='".$mainData['forum_cat_name']."'>\n";
			}
			$subResult = dbquery("SELECT forum_id, forum_name FROM ".DB_FORUMS." WHERE forum_main='".$mainData['forum_id']."'");
			$mainCheckData = dbarray(dbquery("SELECT forum_main FROM ".DB_FORUMS." WHERE forum_id='".$forum_id."'"));
			if ($mainCheckData['forum_main'] == "0") { $sel = ($mainData['forum_id'] == $forum_id ? " selected='selected'" : ""); }
			else { $sel = ""; }
			$forumList .= "<option value='".$mainData['forum_id']."'$sel>".$mainData['forum_name']."</option>\n";
			while ($subData = dbarray($subResult)) {
				if ($mainCheckData['forum_main'] != "0") { $selsub = ($subData['forum_id'] == $forum_id ? " selected='selected'" : ""); }
				else { $selsub = ""; }
				$forumList .= "<option value='".$subData['forum_id']."'$selsub>&nbsp;&minus;".$subData['forum_name']."</option>\n";
			}
		}
		$forumList .= "</optgroup>\n";
		
		return $forumList;
	}
	
	public function forumListAdmin($mainResult, $forum_id) {
		global $fsc_settings, $locale;
		
		$forumList = ""; $currentCat = "";
		if ($forum_id == "0") { $sel = " selected='selected'"; } else { $sel = ""; }
		if ($fsc_settings['fsc_enabled'] == "1" && dbrows($mainResult) != "0") {
			$forumList .= "<option value='0'$sel>".$locale['fsc_015']."</option>\n";
			while ($mainData = dbarray($mainResult)) {
				if ($mainData['forum_cat_name'] != $currentCat) {
					if ($currentCat != "") { $forumList .= "</optgroup>\n"; }
					$currentCat = $mainData['forum_cat_name'];
					$forumList .= "<optgroup label='".$mainData['forum_cat_name']."'>\n";
				}
				$sel = ($mainData['forum_id'] == $forum_id ? " selected='selected'" : "");
				$forumList .= "<option value='".$mainData['forum_id']."'$sel>".$mainData['forum_name']."</option>\n";
				$subResult = dbquery("SELECT forum_id, forum_name FROM ".DB_FORUMS." WHERE forum_main='".$mainData['forum_id']."'");
				while ($subData = dbarray($subResult)) {
					$forumList .= "<option value='".$subData['forum_id']."'>&nbsp;&minus;".$subData['forum_name']."</option>\n";
				}
			}
			$forumList .= "</optgroup>\n";
			
			return $forumList;
		}
	}
	
	public function subCount($forum_id, $standard_count, $type) {
		if ($this->_subCatsEnabled == "1") {
			if ($type == "thread") {
				$subCountResult = dbresult(dbquery("SELECT SUM(forum_threadcount) FROM ".DB_FORUMS." WHERE ".groupaccess('forum_access')." AND forum_main='".$forum_id."' OR forum_id='".$forum_id."'"),0);
				$subCount = ($subCountResult == 0) ? "0" : $subCountResult;
			} elseif ($type == "post") {
				$subCountResult = dbresult(dbquery("SELECT SUM(forum_postcount) FROM ".DB_FORUMS." WHERE ".groupaccess('forum_access')." AND forum_main='".$forum_id."' OR forum_id='".$forum_id."'"),0);
				$subCount = ($subCountResult == 0) ? "0" : $subCountResult;
			}
		} else {
			$subCount = $standard_count;
		}
		
		return $subCount;
	}
}
?>
